
##### 野球 ######################################################################
### 数値を整数化、k の値を変更してアウトになりやすくした (2021.12.21)
### サヨナラ勝ち設定　(2022.12.21)

import tkinter
# import numpy as np
import random
import time
import math        # ★★ math
# time.sleep(0.1)

key=""
index=0
tmr=0
point=0
jun=0
p1=0
p2=0
txt=""
b0x,b0y=-150,550  # ボール 
bx,by=0,0
bax,bay=0,0
s0x,s0y=1050,550  # バット nx()
sx,sy=0,0
sax=0
xl=0            # 打球が飛んでいく方向のｘ座標
yl=0
tl=0            # 打球が飛んでいくときの時間
a=0
b=0
c=0
xd,yd=0,0
cousu=0          # 打球のコース
strik=0
strik_x=0
out=0
out_x=0
hit=0
foul=0
col_0="white"
col_1="white"
col_2="white"
col_3="white"
run=0
tenn=0
x=0
y=0
kai=16
ra=0
total_1,total_2=0,0


score=[      # スコア― ２ｘ９
[0,0,0,0,0,0,0,0,0],
[0,0,0,0,0,0,0,0,0]
]
total_1,total_2=0,0

t=0         # 衝突後の時間
t1=0        # バットスイングの速さ
k=0.001
d=0         # ボールとバットの距離

# ------------------------------------------------------------------------------------

def key_down(e):        # Key Down
    global key
    key=e.keysym
def key_up(e):          # Key Up
    global key
    key=""

def key_in1():          # 投球するボールの設定
    global b0y,bvx
    if key == "e" and b0y>460:       # 高く
        b0y=b0y-10
    if key == "d" and b0y<560:        # 低く
        b0y=b0y+10
    if key == "f" and bvx<12:       # 速く
        bvx=bvx+1
    if key == "s" and bvx>4:        # 遅く
        bvx=bvx-1

def score_0():          # スコア―の初期化
    score=[
    [0,0,0,0,0,0,0,0,0,0],
    [0,0,0,0,0,0,0,0,0,0]
    ]
    total_1,total_2=0,0     # スコア― トータル

def draw_piti():        # ボールの高低、スピード表示
    global boy
    cvs.delete("PITI")    
    draw_text("LOW--HIGH："+str(-0.1*b0y+56),150,220,25,"white","PITI")
    draw_text("SPEED："+str(bvx-3),150,260,25,"white","PITI")

def draw_name():        # ★★ チーム名表示 ★★★★★
#    global boy
#    cvs.delete("PITI")    
    draw_text1("ポン",80,100,20,"black","NAME")
    draw_text1("コツ",80,150,20,"black","NAME")    
    
def key_in2():          # バットの移動（上下） 最初の位置 500
    global sy
    if key == "Up" and sy>=450:
        sy=sy-3
    if key == "Down" and sy<=650:
        sy=sy+3

def draw_ball():        # ボールの描画
    global bx,by
    cvs.delete("BALL")
    cvs.create_image(bx,by,image=img_ball_1,tag="BALL")    
    
def draw_bat():         # バットの描画
    global sx,sy
    cvs.delete("BAT")
    cvs.create_oval(sx-20,sy-20,sx+20,sy+20,fill="orange",tag="BAT") 

def hantei():            # ストライク！ ＆  打球の判定
    global txt,col
    draw_text(txt,700,550,23,col,"HANTEI")

def draw_hit():         # 打球の角度、打点のバットの位置
    global bvy,cousu
    cvs.delete("V")
    draw_text("打球の角度= ",170,340,23,"white","V")
    draw_text("< … -10 … -5 … (0:水平) … 5 … 15,16,17,18 … >",270,370,17,"white","V")
    draw_text("（← -10：ボテボテゴロ　　上がりすぎ：18 →）",275,400,17,"white","V")
    if int(bvy)>=18 or int(bvy)<=-10:
        draw_text(str(int(bvy)),285,340,23,"red","V")
    else:
        draw_text(str(int(bvy)),285,340,23,"pink","V")
        

def draw_line():        # 打球の方向（★★ホームから打球が飛んだ軌跡）
                        # ２点(1000,426),(xl,yl)を通り、開きa の放物線
                        # a=0 => 打球は直線
    global xl,yl,a,b,c,xd,yd,bvy,ra
    ra=-4
    if sx>=940:
        ra=-3
    if sx>=960:
        ra=-2
    if sx>=980:
        ra=-1
        a=0
    if sx>=1000:
        ra=1
        a=0
    a=0.005
    if bvy<0:
        a=0
    if bvy>=0 and bvy<2:
        a=0.0005
    if bvy>=2 and bvy<5:
        a=0.001
    if bvy>=5 and bvy<10:
        a=0.002
    if bvy>=10:
        a=0.006
    #a=0.005+bvy/1000
    b=(426-yl)/(1000-xl)-a*(1000+xl)
    c=int((yl*1000-426*xl)/(1000-xl)+a*1000*xl)
    for xd in range(1000,xl,ra):
        yd=int(a*xd*xd+b*xd+c)

        cvs.create_oval(xd-2,yd-2,xd+2,yd+2,fill="white",tag="DAKYUU")
    cvs.create_line(1000,426,xd,yd,fill="black",tag="DAKYUU")      # 打球の影       
   # cvs.create_line(xl,yl,1002,426,fill="yellow",width=3,tag="DA")

def draw_out():         # アウトカウントの表示
    global out_x
    cvs.delete("OUT")
    for i in range(0,out_x):
        cvs.create_oval(1120+35*i,205-12,1144+35*i,205+12,fill="red",width=2,tag="OUT")

def draw_strik():       # ストライクカウントの表示
    global strik_x
    cvs.delete("STRIK")
    for i in range(0,strik_x):
        cvs.create_oval(1120+35*i,153-12,1144+35*i,153+12,fill="yellow",width=2,tag="STRIK")

def draw_sansin():      # 三振の表示
    draw_text("三 振",1120,400,25,"yellow","SANSIN") 

def draw_change():      # チェンジの表示
    draw_text("チェンジ",1150,300,30,"red","CHANGE")

def draw_base():        # ベース表示（ランナー有りで赤）
    global col_1,col_2,col_3,col_0  # col_0: バッター
    cvs.create_rectangle(987,251,1002,266,fill=col_1)      # １塁
    cvs.create_rectangle(827,251,842,266,fill=col_2)      # ２塁
    cvs.create_rectangle(827,411,842,426,fill=col_3)      # ３塁
    cvs.create_polygon(982,418,991,426,1002,426,1002,415,994,406,fill="white")
    # ホーム 982,418,991,426,1002,426,1002,415,994,406
    cvs.create_oval(972,422,987,437,fill=col_0,tag="BATTER")     # バッター


def draw_tenn1():  #  スコア―ボード
    global kai,x,y,tenn,total_1,total_2,score   # kai: 0,1,2,---,16,17
    cvs.delete("TENN")
    x=int(kai/2)
    y=kai%2
    score[y][x]=tenn   
    draw_text1(tenn,140+40*x,100+50*y,25,"black","TENN") 
    cvs.create_rectangle(128+40*x,116+49*y,152+40*x,119+49*y,fill="red",tag="TENN")
    for i in range(kai):
        x=int(i/2)
        y=i%2
        draw_text1(score[y][x],140+40*x,100+50*y,25,"black","TENN")
    total_1=0       # 以下、合計の表示
    total_2=0
    for i in range(0,9):
        total_1=total_1+score[0][i]
        total_2=total_2+score[1][i]
    draw_text1(total_1,523,100,25,"black","TENN")
    draw_text1(total_2,523,150,25,"black","TENN")    
               
def draw_course():      # L  R の表示
    global txt
    draw_text("L ←  → R",950,650,20,"pink","Z")
    draw_text("L",880,350,20,"pink","Z")
    draw_text("R",933,307,20,"pink","Z")
    
def draw_text(txt,x,y,siz,col,tg):      # テキスト表示（影付き）
    fnt=("Times New Roman",siz,"bold")
    cvs.create_text(x+3,y+3,text=txt,fill="black",font=fnt,tag=tg)
    cvs.create_text(x,y,text=txt,fill=col,font=fnt,tag=tg)

def draw_text1(txt,x,y,siz,col,tg):      # テキスト表示（影無し）
    fnt=("Times New Roman",siz,"bold")
    cvs.create_text(x,y,text=txt,fill=col,font=fnt,tag=tg)        


def main_proc(): # ====================================================================
    global tmr,index,point,p1,p2,jun,t,t1,k,d,txt,xl,yl,cousu,col,total_1,total_2
    global b0x,b0y,bx,by,bvx,bvy,bax,bay,k,col_1,col_2,col_3,col_0
    global s0x,s0y,sx,sy,sax,hit,out,out_x,foul,strik,strik_x,run,tenn,kai,x,y

    if index==0:
        tenn=0
        total_1,total_2=0,0        
        kai=0
        x,y=0,0             #  x=int(kai/2) , y=kai%2
        cvs.delete("TENN")
        cvs.delete("CHANGE")
        cvs.delete("STRIK")
        cvs.delete("OUT")
        draw_base()
        score_0()           # score 初期化
        draw_name()
        index=1

    elif index==1:
        draw_base()            
        draw_course()       # L、R の表示
        cvs.delete("DA")        # 打球の方向を消す
        cvs.delete("DAKYUU")
        cvs.delete("POINT")
        cvs.delete("BAT")
        cvs.delete("HANTEI")         # 「ストライク」を消す
        out=0               # 打球が out のとき１（カウントではない）
        strik=0
        foul=0              # 打球がファウルのとき１
        hit=0               # 打球が ヒットのとき１，２，３，４
        t=0
        t1=0
        s0x=1070+random.randint(0,80)
        s0y=510+random.randint(0,80)     # バット構え位置
        b0x=-150
        b0y=510   # ボールのスタート位置
        bvx=8                # ボールのｘ方向初速、y方向は0      4=<x<=12
        bax,bay=-0.002,0.0005   # ボールのｘ方向加速度（空気抵抗）
        k=0.04               # ボールの速度係数
        bx,by=b0x,b0y
        sx,sy=s0x,s0y
        draw_piti()
        tmr=0
        index=2
        
    elif index==2:
        if tmr==10:
            draw_bat()
            bx,by=b0x,b0y
            draw_ball()
            key_in1()       # 投げるボールの設定（高低・スピード）
            draw_piti()
            if key=="space":        # 投球開始
                tmr=0
                index=3
            else:
                tmr=0
                index=2
                
    elif index==3:          # ---------- ボールの動き --------------------------
        if bx>1200:# or by>660:         # 捕手位置
            tmr=0
            txt="ストライク！"        # バットが振られず ストライク
            col="yellow"
            strik=1
            index=8
        else:    
            if tmr==1:      # ボールを描いてから消えるまでの時間
                t=t+2       # ボールの移動速度
                index=4
                
    elif index==4:
        bx=int(b0x+bvx*t+bax*t*t)      #   bax=-0.0013
        by=int(b0y+bay*t*t)           #   bay=0.00005
        draw_ball()         # ボールの中心（bx,by）
        key_in2()           # バットの上下
        draw_bat()          # バット中心（sx,sy）半径 20
        if key=="Left":     # バット スイング
            tmr=0
            index=5
        else:
            tmr=0
            index=3
            
    elif index==5:
        if tmr==1:          # ボールを描いてから消えるまでの時間
            t=t+2           # ボールの移動距離
            t1=t1+4         # バットの移動距離
            if sx<850:
                t1=0        # 空振りしたバットを止める
            index=6

    elif index==6:
        sx=int(sx-0.2*t1)         # バットスイング
        draw_bat()
        bx=int(b0x+bvx*t+bax*t*t)      #
        by=int(b0y+bay*t*t)           # 
        draw_ball()
        if bx>1200: #or by>660:
            tmr=0
            txt="ストライク！"    # 空振り or 見逃しでストライク
            col="yellow"
            strik=1
            index=8
        else:
            d=(bx-sx)*(bx-sx)+(by-sy)*(by-sy)
            if d<=2200 and bx<sx and bx>900 and bx<1010:   # バットにボールが当たった  bx: ボールの中心                     
                b0x=sx-int(math.sqrt(2200-(by-sy)*(by-sy)))  #                      √
                b0y=by
                k=0.6  ##### 0.5 から変更（打球が上がりやすくアウトになりやすい）
                bvx=k*(bx-sx)
                bvx=int(bvx)
                bvy=k*(by-sy)
                bvy=int(bvy)
                t=0
                tmr=0
                index=7
            else:
                tmr=0
                index=5

    elif index==7:          # 打球の描写
        if tmr==3:                          # tmr:3 -> 5
            tmr=0
            cvs.delete("BALL")
            bx=b0x-13*t
            by=b0y+k*bvy*t
            draw_ball()
            t=t+2
            if bx<-20 or bx>1320 or by<-20 or by>720:   # ボールが画面から消えたら（判定）
                sx=sx-20        # sx: バットの中心 sx-20;バットの左端 
                                # sx: バットとボールの接点の位置（振りが早い、遅い）
                bvy=-bvy
                if sx<893:                 ### (1) 
                    if bvy<-10:
                        xl,yl=844,455
                        txt="ファウル"
                        col="orange"
                        foul=1
                    if bvy>=-10 and bvy<18:
                        xl,yl=640,470
                        txt="ファウル"
                        col="orange"
                        foul=1
                    if bvy>=18:
                        xl,yl=658,468
                        tft="ファウル"
                        col="orange"
                        foul=1                        

                if sx>=893 and sx<900:      ### (2)
                    if bvy<-10:
                        xl,yl=835,435
                        txt="ファウル"
                        col="orange"
                        foul=1
                    if bvy>=-10 and bvy<18:
                        xl,yl=630,445
                        txt="ファウル"
                        col="orange"
                        foul=1
                    if bvy>=18:
                        xl,yl=660,440
                        tft="アウト"
                        col="red"
                        out=1                 

                if sx>=900 and sx<906:      ### (3)
                    if bvy<-10:             
                        xl,yl=830,420
                        txt="アウト"
                        col="red"
                        bvx
                        out=1
                    if bvy>=-10 and bvy<-5:
                        xl,yl=810,412
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=-5 and bvy<18: 
                        xl,yl=640,414
                        txt="２Ｂヒット"
                        col="white"
                        hit=2
                    if bvy>=18:             
                        xl,yl=658,416
                        txt="アウト"
                        col="red"
                        out=1
                        
                if sx>=906 and sx<912:      ### (4)
                    if bvy<-10:
                        xl,yl=828,407
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=-10 and bvy<5:
                        xl,yl=810,405
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=5 and bvy<18:
                        xl,yl=607,383
                        txt="２Ｂヒット"
                        col="white"
                        hit=2
                    if bvy>=18:
                        xl,yl=658,390
                        txt="アウト"
                        col="red"
                        out=1
           
                if sx>=912 and sx<920:      ### (5)
                    if bvy<-10:
                        xl,yl=830,390
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=-10 and bvy<5:
                        xl,yl=810,385
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=5 and bvy<12:
                        xl,yl=680,350
                        txt="ヒット"
                        col="white"
                        hit=1
                    if bvy>=12 and bvy<17:
                        xl,yl=659,347
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=17 and bvy<18:
                        xl,yl=600,340
                        txt="２Ｂヒット"
                        col="white"
                        hit=2
                    if bvy>=18:
                        xl,yl=660,347
                        txt="アウト"
                        col="red"
                        out=1

                if sx>=920 and sx<928:      ### (6)
                    if  bvy<-10:
                        xl,yl=830,360
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=-10 and bvy<10:
                        xl,yl=680,294
                        txt="ヒット"
                        col="white"
                        hit=1
                    if bvy>=10 and bvy<16:
                        xl,yl=659,285
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=16 and bvy<17:
                        xl,yl=615,270
                        txt="２Ｂヒット"
                        col="white"
                        hit=2
                    if bvy>=17 and bvy<18:
                        xl,yl=560,280
                        txt="ホームラン！"    # HR
                        col="gold"
                        hit=4                    
                    if bvy>=18:
                        xl,yl=659,285
                        txt="アウト"
                        col="red"
                        out=1

                if sx>=928 and sx<937:      ### (7)
                    if bvy<-10:
                        xl,yl=843,330
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=-10 and bvy<5:
                        xl,yl=790,297
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=5 and bvy<17:
                        xl,yl=665,225
                        txt="２Ｂヒット"
                        col="white"
                        hit=2
                    if bvy>=17 and bvy<18:
                        xl,yl=610,195
                        txt="３Ｂヒット"
                        col="white"
                        hit=3
                    if bvy>=18:
                        xl,yl=665,225
                        txt="アウト"
                        col="red"
                        out=1
                    
                if sx>=937 and sx<942:      ### (8)
                    if bvy<-10:
                        xl,yl=850,317
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=-10 and bvy<5:
                        xl,yl=790,270
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=5 and bvy<12:
                        xl,yl=702,206
                        txt="ヒット"
                        col="white"
                        hit=1
                    if bvy>=12 and bvy<16:
                        xl,yl=683,195
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=16 and bvy<17:
                        xl,yl=647,170
                        txt="２Ｂヒット"
                        col="white"
                        hit=2
                    if bvy>=17 and bvy<18:    
                        xl,yl=622,152
                        txt="３Ｂヒット"
                        col="white"
                        hit=3
                    if bvy>=18:
                        xl,yl=683,195
                        txt="アウト"
                        col="red"
                        out=1
                        
                if sx>=942 and sx<947:      ### (9)
                    if bvy<-10:
                        xl,yl=860,303
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=-10 and bvy<10:
                        xl,yl=722,185
                        txt="ヒット"
                        col="white"
                        hit=1
                    if bvy>=10 and bvy<16:
                        xl,yl=706,172
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=16 and bvy<17:
                        xl,yl=645,117
                        txt="３Ｂヒット"
                        col="white"
                        hit=3
                    if bvy>=17 and bvy<18:
                        xl,yl=625,100
                        txt="ホームラン！"    # HR
                        col="gold"
                        hit=4
                    if bvy>=18:
                        xl,yl=706,172
                        txt="アウト"
                        col="red"
                        out=1
            
                if sx>=947 and sx<953:      ### (10)
                    if bvy<-5:
                        xl,yl=901,326   # ピッチャーゴロ
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=-5 and bvy<10:
                        xl,yl=743,165
                        txt="ヒット"
                        col="white"
                        hit=1
                    if bvy>=10 and bvy<16:
                        xl,yl=727,152
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=16 and bvy<17:
                        xl,yl=666,92
                        txt="３Ｂヒット"
                        col="white"
                        hit=3
                    if bvy>=17 and bvy<18:
                        xl,yl=649,73
                        txt="ホームラン！"    # HR
                        col="gold"
                        hit=4
                    if bvy>=18:
                        xl,yl=727,152
                        txt="アウト"
                        col="red"
                        out=1                    
                    
                if sx>=953 and sx<958:      ### (11)
                    if bvy<-10:
                        xl,yl=883,283
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=-10 and bvy<10:
                        xl,yl=764,145
                        txt="ヒット"
                        col="white"
                        hit=1
                    if bvy>=10 and bvy<16:
                        xl,yl=750,128
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=16 and bvy<17:
                        xl,yl=698,65
                        txt="３Ｂヒット"
                        col="white"
                        hit=3
                    if bvy>=17 and bvy<18:
                        xl,yl=682,48
                        txt="ホームラン！"    # HR
                        col="gold"
                        hit=4
                    if bvy>=18:
                        xl,yl=750,128
                        txt="アウト"
                        col="red"
                        out=1
                        
                if sx>=958 and sx<963:      ### (12)
                    if bvy<-10:
                        xl,yl=892,275
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=-10 and bvy<10:
                        xl,yl=850,214
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=10 and bvy<12:
                        xl,yl=785,124
                        txt="ヒット"
                        col="white"
                        hit=1
                    if bvy>=12 and bvy<16:
                        xl,yl=772,107
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=16 and bvy<17:
                        xl,yl=746,71
                        txt="２Ｂヒット"
                        col="white"
                        hit=2                        
                    if bvy>=17 and bvy<18:
                        xl,yl=726,44
                        txt="３Ｂヒット"
                        col="white"
                        hit=3
                    if bvy>=18:
                        xl,yl=772,107
                        txt="アウト"
                        col="red"
                        out=1
                        
                if sx>=963 and sx<972:      ### (13)
                    if bvy<-10:
                        xl,yl=905,267
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=-10 and bvy<10:
                        xl,yl=875,214
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=10 and bvy<16:
                        xl,yl=785,53
                        txt="２Ｂヒット"
                        col="white"
                        hit=2
                    if bvy>=16 and bvy<18:
                        xl,yl=770,25
                        txt="３Ｂヒット"
                        col="white"
                        hit=3
                    if bvy>=18:
                        xl,yl=799,84
                        txt="アウト"
                        col="red"
                        out=1
                    
                if sx>=972 and sx<980:      ### (14)
                    if  bvy<-10:
                        xl,yl=935,255
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=-10 and bvy<10:
                        xl,yl=875,104
                        txt="ヒット"
                        col="white"
                        hit=1
                    if bvy>=10 and bvy<16:
                        xl,yl=867,84
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=16 and bvy<17:
                        xl,yl=848,40
                        txt="２Ｂヒット"
                        col="white"
                        hit=2
                    if bvy>=17 and bvy<18:
                        xl,yl=850,-20
                        txt="ホームラン！"    # HR
                        col="gold"
                        hit=4
                    if bvy>=18:
                        xl,yl=867,84
                        txt="アウト"
                        col="red"
                        out=1

                if sx>=980 and sx<988:      ### (15)
                    if bvy<-10:
                        xl,yl=963,251
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=-10 and bvy<10:
                        xl,yl=958,234
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=10 and bvy<12:
                        xl,yl=932,104
                        txt="ヒット"
                        col="white"
                        hit=1
                    if bvy>=12 and bvy<16:
                        xl,yl=925,84
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=16 and bvy<18:
                        xl,yl=916,42
                        txt="２Ｂヒット"
                        col="white"
                        hit=2
                    if bvy>=18:
                        xl,yl=925,84
                        txt="アウト"
                        col="red"
                        out=1
 
                if sx>=988 and sx<994:      ### (16)
                    if bvy<-10:
                        xl,yl=982,252
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=-10 and bvy<10:
                        xl,yl=980,234
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=10 and bvy<18:
                        xl,yl=960,20
                        txt="２Ｂヒット"
                        col="white"
                        hit=2
                    if bvy>=18:
                        xl,yl=965,84
                        txt="アウト"
                        col="red"
                        out=1
                         
                if sx>=994 and sx<1000:     ### (17)
                    if bvy<-10:             
                        xl,yl=995,252
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=-10 and bvy<-5:
                        xl,yl=981,234
                        txt="アウト"
                        col="red"
                        out=1
                    if bvy>=-5 and bvy<18: 
                        xl,yl=988,50
                        txt="２Ｂヒット"
                        col="white"
                        hit=2
                    if bvy>=18:             
                        xl,yl=990,84
                        txt="アウト"
                        col="red"
                        out=1

                if sx>=1000 and sx<1007:    ### (18)
                    if bvy<-10:
                        xl,yl=1010,254
                        txt="ファウル"
                        col="orange"
                        foul=1
                    if bvy>=-10 and bvy<18:
                        xl,yl=1024,50
                        txt="ファウル"
                        col="orange"
                        foul=1
                    if bvy>=18:
                        xl,yl=1020,84
                        tft="アウト"
                        col="red"
                        out=1                 

                if sx>=1007:                ### (19)
                    if bvy<-10:
                        xl,yl=1030,254
                        txt="ファウル"
                        col="orange"
                        foul=1
                    if bvy>=-10 and bvy<18:
                        xl,yl=1070,70
                        txt="ファウル"
                        col="orange"
                        foul=1
                    if bvy>=18:
                        xl,yl=1065,84
                        tft="ファウル"
                        col="orange"
                        foul=1                        

                draw_line()             # 球の軌跡
                draw_hit()
                tmr=0
                index=8
                
    elif index==8:                
        hantei()    # ストライク ＆ 打球の表示

        if hit>0:       ### ---------------------------- HIT -----------------
            strik_x=0     # ストライクカウントクリアー
            draw_strik()
            if hit==1:
                if col_3=="red":
                    tenn=tenn+1         # TENN
                    col_3="white"
                if col_2=="red":
                    col_3="red"
                    col_2="white"
                if col_1=="red":
                    col_2="red"
                col_1="red"
            if hit==2:
                if col_3=="red":
                    tenn=tenn+1         # TENN
                    col_3="white"
                if col_2=="red":
                    tenn=tenn+1
                    col_2="white"
                if col_1=="red":
                    col_3="red"
                    col_1="white"
                col_2="red"
            if hit==3:
                if col_3=="red":
                    tenn=tenn+1         # TENN
                    col_3="white"
                if col_2=="red":
                    tenn=tenn+1
                    col_2="white"
                if col_1=="red":
                    tenn=tenn+1
                    col_1="white"
                col_3="red"
            if hit==4:
                if col_3=="red":
                    tenn=tenn+1         # TENN
                    col_3="white"
                if col_2=="red":
                    tenn=tenn+1
                    col_2="white"
                if col_1=="red":
                    tenn=tenn+1
                    col_1="white"
                tenn=tenn+1             # TENN
            draw_base()

        if out==1:      ### ------------------------------ OUT -----------------
            strik_x=0
            draw_strik()
            out_x=out_x+1
            draw_out()

        if strik==1:    ### ----------------------------- STRIKE ----------
            strik_x=strik_x+1
            draw_strik()
            if strik_x==3:
                draw_sansin()
                strik_x=0
                out_x=out_x+1
                draw_out()

        if foul==1:     #### ----------------------------- FOUL ----------
            strik_x=strik_x+1
            if strik_x==3:
                strik_x=2
            draw_strik()
        tmr=0
        index=9


    elif index==9:
        draw_tenn1()
        if kai==17 and total_2>total_1:
            index=11
        else:
            if out_x==3:
                draw_tenn1()
                tenn=0
                draw_change()       # CHANGE
                out_x=0
                col_0="white"
                col_1="white"
                col_2="white"
                col_3="white"
                draw_base()
                if kai==16 and total_2>total_1:  ##### 後攻がリード (kai: 0,1,2,3,---,16,17)
                    draw_text1("x",140+40*8,100+50*1,25,"black","TENN") 
                    index=11
                else:
                    if kai==17:          # 最終回(17)   ９回表：16
                        index=11
                    else:
                        kai=kai+1
                        index=10
            else:
                index=10
        
    elif index==10:
        if tmr==180:      #### SPEED (200) ##################### 
            tmr=0
            cvs.delete("SANSIN")
            cvs.delete("CHANGE")
            draw_strik()
            draw_out()
            cvs.delete("BALL")
            index=1

    elif index==11:
        cvs.delete("HANTEI")
        if tmr==10:
            draw_text("ゲーム セット",650,500,45,"red","SET")  
            draw_text("Push［→］",650,600,45,"white","YA")
        if tmr==60:
            tmr=0
            cvs.delete("YA")
            if key=="Right":
                cvs.delete("SET")
                tmr=0
                index=0
            else:
                index=11
            
   
    tmr=tmr+1    
    root.after(2,main_proc)       # root.after 2->6  ★★ スピード ★★
# =========================================================================================
    
root=tkinter.Tk()
root.title("野球")
root.bind("<KeyPress>",key_down)
root.bind("<KeyRelease>",key_up)
img_score=tkinter.PhotoImage(file="score.png")
img_count=tkinter.PhotoImage(file="count.png")
img_ball_1=tkinter.PhotoImage(file="ball_1.png")
cvs=tkinter.Canvas(width=1300,height=700,bg="green")    # Canvas:1300x800
cvs.create_image(300,100,image=img_score,tag="SCORE0")
cvs.create_image(1150,150,image=img_count,tag="COUNT")   
cvs.create_rectangle(948,450,952,645,fill="red")        # 打撃位置 x=950, 445<y<635        
cvs.create_rectangle(900,450,902,645,fill="white")      # 打撃位置前ライン
cvs.create_rectangle(998,450,1000,645,fill="white")     # 打撃位置後ライン
cvs.create_rectangle(850,680,1270,690,fill="white")     # バッターボックス
cvs.create_rectangle(1230,420,1250,680,fill="black")    # キャッチャー
cvs.create_rectangle(1000,0,1002,426,fill="white")        # ライト線
cvs.create_rectangle(500,424,1000,426,fill="white")      # レフト線
cvs.create_arc(576,0,1168,592,outline="white",start=64,extent=142,style=tkinter.ARC)  # 外野フェンス                                         
cvs.create_line(625,50,1002,426,fill="red",width=1)     # 中央線（赤）

cvs.create_line(810,370,810,412,fill="black",width=3)   # 3
cvs.create_oval(810-8,391-8,810+8,391+8,fill="black")
cvs.create_line(790,260,790,315,fill="black",width=3)   # SS
cvs.create_oval(790-8,287-8,790+8,287+8,fill="black")
cvs.create_line(660,260,660,375,fill="black",width=3)   # L
cvs.create_oval(660-8,312-8,660+8,312+8,fill="black")
cvs.create_line(947,234,989,234,fill="black",width=3)   # 1
cvs.create_oval(968-8,234-8,968+8,234+8,fill="black")
cvs.create_line(836,214,891,214,fill="black",width=3)   # 2
cvs.create_oval(863-8,214-8,863+8,214+8,fill="black")
cvs.create_line(836,84,951,84,fill="black",width=3)     # R
cvs.create_oval(888-8,84-8,888+8,84+8,fill="black")
cvs.create_line(675,204,780,99,fill="black",width=3)    # C
cvs.create_oval(726-8,151-8,726+8,151+8,fill="black")
cvs.create_oval(901-8,326-8,901+8,326+8,fill="black")   # Pit
cvs.create_oval(1017-8,441-8,1017+8,441+8,fill="black") # cat
cvs.pack()                
main_proc()
root.mainloop()

